Index: trunk/SophyaExt/FitsIOServer/exclude
===================================================================
--- trunk/SophyaExt/FitsIOServer/exclude	(revision 1220)
+++ trunk/SophyaExt/FitsIOServer/exclude	(revision 1221)
@@ -1,2 +1,6 @@
 fitsioserver.cc
-
+fitsbntbllinereader.cc.encours
+fitsbntbllinereaderXX.cc
+fitsbntbllinereader.travail.cc
+fitsbntbllinereader.sv.cc
+fitsspherethetaphi.cc
Index: trunk/SophyaExt/FitsIOServer/fitsbntbllineRW.cc
===================================================================
--- trunk/SophyaExt/FitsIOServer/fitsbntbllineRW.cc	(revision 1220)
+++ trunk/SophyaExt/FitsIOServer/fitsbntbllineRW.cc	(revision 1221)
@@ -100,5 +100,5 @@
 
 
-FITS_BntblLineWriter::FITS_BntblLineWriter(char inputfile[],int dc, int fc,int ic, int cc, vector<string> names,DVList& dvl,  WriteMode wrm)
+FITS_BntblLineWriter::FITS_BntblLineWriter(char inputfile[],int dc, int fc,int ic, int cc, vector<string> names,DVList* ptr_dvl,  WriteMode wrm)
 {
   int k;
@@ -131,5 +131,5 @@
   string extname("Lines_on_Binary_tbl"); 
 
-  outFits_->makeHeaderBntblOnFits(types, names, 1, nbcols, dvl, extname,StringSizes); 
+  outFits_->makeHeaderBntblOnFits(types, names, 1, nbcols, ptr_dvl, extname,StringSizes); 
     ligne_.setFormat(dc, fc, ic, cc, names);
 
Index: trunk/SophyaExt/FitsIOServer/fitsbntbllineRW.h
===================================================================
--- trunk/SophyaExt/FitsIOServer/fitsbntbllineRW.h	(revision 1220)
+++ trunk/SophyaExt/FitsIOServer/fitsbntbllineRW.h	(revision 1221)
@@ -61,5 +61,5 @@
 
 public:
- FITS_BntblLineWriter(char inputfile[],int dc, int fc, int ic, int cc, vector<string> names, DVList& dvl, WriteMode wrm = clear);
+ FITS_BntblLineWriter(char inputfile[],int dc, int fc, int ic, int cc, vector<string> names, DVList* dvl=NULL, WriteMode wrm = clear);
 ~FITS_BntblLineWriter();
  void WriteNextLine( BnTblLine& WorkLine);
Index: trunk/SophyaExt/FitsIOServer/fitsfile.cc
===================================================================
--- trunk/SophyaExt/FitsIOServer/fitsfile.cc	(revision 1220)
+++ trunk/SophyaExt/FitsIOServer/fitsfile.cc	(revision 1221)
@@ -1158,5 +1158,5 @@
 \param <naxisn>  array containind sizes of the different dimensions
 */
-void FitsOutFile::makeHeaderImageOnFits(char type, int nbdim, int* naxisn,  DVList &dvl) 
+void FitsOutFile::makeHeaderImageOnFits(char type, int nbdim, int* naxisn,  DVList* ptr_dvl) 
 {
   int status = 0;
@@ -1191,5 +1191,5 @@
   // write supplementary keywords
   //  dvl.Print();
-  addKeywordsOfDVList(dvl);
+  if (ptr_dvl != NULL) addKeywordsOfDVList(*ptr_dvl);
 
   delete [] naxes;
@@ -1254,5 +1254,5 @@
 \param <taille_des_chaines> vector containing the number of characters of  data  for each char* typed column, with order of appearance in 'fieldType'
 */
-void FitsOutFile::makeHeaderBntblOnFits( string fieldType, vector<string> Noms, int nentries, int tfields, DVList &dvl, string extname, vector<int> taille_des_chaines) 
+void FitsOutFile::makeHeaderBntblOnFits( string fieldType, vector<string> Noms, int nentries, int tfields, DVList* ptr_dvl, string extname, vector<int> taille_des_chaines) 
 { 
   int k;
@@ -1345,5 +1345,5 @@
   //
   // write supplementary keywords
-  addKeywordsOfDVList(dvl);
+  if (ptr_dvl != NULL) addKeywordsOfDVList(*ptr_dvl);
 }
 
Index: trunk/SophyaExt/FitsIOServer/fitsfile.h
===================================================================
--- trunk/SophyaExt/FitsIOServer/fitsfile.h	(revision 1220)
+++ trunk/SophyaExt/FitsIOServer/fitsfile.h	(revision 1221)
@@ -210,5 +210,5 @@
 
    inline void firstImageOnPrimaryHeader() {imageOnPrimary_=true;}
-   void makeHeaderImageOnFits(char type, int nbdim, int* naxisn, DVList &dvl) ;
+   void makeHeaderImageOnFits(char type, int nbdim, int* naxisn, DVList* dvl) ;
    void PutImageToFits( int nbData, double* map) const;
    void PutImageToFits(int nbData, float* map ) const;
@@ -223,5 +223,5 @@
 
 
-   void makeHeaderBntblOnFits ( string fieldType, vector<string> Noms, int nentries, int tfields, DVList &dvl, string extname,  vector<int> taille_des_chaines) ;
+   void makeHeaderBntblOnFits ( string fieldType, vector<string> Noms, int nentries, int tfields, DVList* dvl, string extname,  vector<int> taille_des_chaines) ;
    void PutColToFits(int nocol, int nentries, double* donnees) const;
    void PutColToFits(int nocol, int nentries, float* donnees) const;
Index: trunk/SophyaExt/FitsIOServer/fitslocalmap.cc
===================================================================
--- trunk/SophyaExt/FitsIOServer/fitslocalmap.cc	(revision 1220)
+++ trunk/SophyaExt/FitsIOServer/fitslocalmap.cc	(revision 1221)
@@ -174,5 +174,5 @@
       }
   vector<int> dummy;
-  os.makeHeaderBntblOnFits(Type, Noms, dobj_->NbPixels(), 1, dvl, extname, dummy);
+  os.makeHeaderBntblOnFits(Type, Noms, dobj_->NbPixels(), 1, &dvl, extname, dummy);
   os.PutColToFits(0,  dobj_->NbPixels(), dobj_->DataBlock().Data()); 
 
Index: trunk/SophyaExt/FitsIOServer/fitsntuple.cc
===================================================================
--- trunk/SophyaExt/FitsIOServer/fitsntuple.cc	(revision 1220)
+++ trunk/SophyaExt/FitsIOServer/fitsntuple.cc	(revision 1221)
@@ -172,5 +172,5 @@
   vector<int> dummy;
 
-  os.makeHeaderBntblOnFits(type,Noms, nentries, ncols, dvl, extname, dummy);
+  os.makeHeaderBntblOnFits(type,Noms, nentries, ncols, &dvl, extname, dummy);
    float* column =  new float[nentries];
    for (k=0; k<ncols;k++)
Index: trunk/SophyaExt/FitsIOServer/fitsspherehealpix.cc
===================================================================
--- trunk/SophyaExt/FitsIOServer/fitsspherehealpix.cc	(revision 1220)
+++ trunk/SophyaExt/FitsIOServer/fitsspherehealpix.cc	(revision 1221)
@@ -113,5 +113,5 @@
       }
   vector<int> dummy;
-  os.makeHeaderBntblOnFits(Type, Noms, nPix, 1, dvl, extname, dummy);
+  os.makeHeaderBntblOnFits(Type, Noms, nPix, 1, &dvl, extname, dummy);
   os.PutColToFits(0,  nPix, dobj_->pixels_.Data()); 
 } 
Index: trunk/SophyaExt/FitsIOServer/fitstarray.cc
===================================================================
--- trunk/SophyaExt/FitsIOServer/fitstarray.cc	(revision 1220)
+++ trunk/SophyaExt/FitsIOServer/fitstarray.cc	(revision 1221)
@@ -134,5 +134,5 @@
     }
   cout << " nombre total d'elements a copier " << nbels << endl;
-  os.makeHeaderImageOnFits(type, nbdim, naxisn, dobj_->Info());
+  os.makeHeaderImageOnFits(type, nbdim, naxisn, &dobj_->Info());
   if (!dobj_->IsPacked()) 
     {
Index: trunk/SophyaExt/FitsIOServer/fitsxntuple.cc
===================================================================
--- trunk/SophyaExt/FitsIOServer/fitsxntuple.cc	(revision 1220)
+++ trunk/SophyaExt/FitsIOServer/fitsxntuple.cc	(revision 1221)
@@ -227,5 +227,5 @@
   vector<int> StringSizes(dobj_->NSVar());
   for (k=0; k< StringSizes.size(); k++) StringSizes[k]=dobj_->mStrSz;
-  os.makeHeaderBntblOnFits(types, Noms, nrows, ncols, dvl, extname,StringSizes); 
+  os.makeHeaderBntblOnFits(types, Noms, nrows, ncols, &dvl, extname,StringSizes); 
    
   int compt=0; 